#!/bin/sh

res='fail'
mod_name=$1
if [ "${module_name}" == "" ];then
  module_name="ElephantDrive"
fi

. /raid/data/module/${module_name}/sys/lib/libsys
/raid/data/module/cfg/module.rc/"$module_name.rc" stop

/opt/bin/sqlite /raid/data/module/cfg/module.db "delete from module where name = '$module_name'"
/opt/bin/sqlite /raid/data/module/cfg/module.db "delete from mod where module = '$module_name'"

# remove module apache configuration from apache.conf
cd /raid/data/module/cfg/
for i in httpd.disable ssl.disable
do
	apache_start=`grep ^#$module_name\ start -n $i|cut -d ':' -f1`
	apache_end=`grep ^#$module_name\ end -n $i|cut -d ':' -f1`
	apache_total=`cat $i|wc -l`
	if [ "$apache_start" != "" ] && [ "$apache_end" != "" ]; then
		head -n $(($apache_start-1)) $i > front.conf
		tail -n $(($apache_total-$apache_end)) $i > back.conf
		cat back.conf >> front.conf
		mv front.conf $i
		rm back.conf
	fi
done
cd -

set_msg_log "$module_name" "uninstall"
set_event "$module_name" "1002" "info" "no" 
rm -rf "/raid/data/module/cfg/module.rc/$module_name.rc"
rm -rf "/raid/data/module/$module_name"
rm -f "/img/htdocs/modules/$module_name"
res='pass'

echo $res
