<?php
session_start();
$module_name="ElephantDrive";
$modulepath="/raid/data/module/$module_name";
require_once($modulepath.'/www/ckauth.html');
require_once($modulepath."/sys/lang/" . $_SESSION['lang'] . "/" . $module_name);
$sqlite="/opt/bin/sqlite";
$confdb=$modulepath."/sys/etc/elephantdrive.db";
$log_path=$modulepath."/sys/var/log/elephantdrive.log.tmp";
$status_path=$modulepath."/sys/var/lib/elephantdrive/status";

$enable=trim($_POST["_elephant"]);
$email=trim($_POST["_email"]);
$password=trim($_POST["_password"]);
$o_enable=trim(shell_exec("$sqlite $confdb \"select v from conf where k='elephant_enable'\""));
$o_email=trim(shell_exec("$sqlite $confdb \"select v from conf where k='email'\""));
$o_password=trim(shell_exec("$sqlite $confdb \"select v from conf where k='password'\""));

function getPasswordHash($pwd) {
	$hash = md5($pwd);
	$len = strlen($hash);
	for ($i = 0; $i < $len; $i = $i + 2) {
		$byte .= intval(substr($hash, $i, 2), 16);
	}
	return $byte;
}

function getAutoLoginToken($user, $pwd) {
	$passhash = getPasswordHash($pwd);

	date_default_timezone_set("UTC");

	$date = date("Y/m/d  H:i:s");
	$data = $user . "|" . $passhash . "|" . $date;

	return "https://vault.elephantdrive.com/account/autologin.aspx".
			"?user=".urlencode($user).
			"&session=".urlencode(strtoupper(base64_encode(hash_hmac("sha1", $data, $passhash, true)))).
			"&date=".urlencode($date).
			"&dname=".urlencode(trim(`hostname`)).
			"&tab=naswizard"
	;
}

$ac=trim($_POST["ac"]);

if ($ac=="update"){
  $status=trim(file_get_contents($status_path));
	$status = str_replace(array("\n"), '; ', $status);
	if($status == ""){
		$status = 'Disabled';
	}
  $version=trim(shell_exec("$modulepath/bin/elephantdrive.sh version"));
	$autologin = getAutoLoginToken($o_email, $o_password);
  echo "{success:false, msg:'".$status . "', version:'".$version."', autologin:'".$autologin."'}";
  exit;
}else if ($ac=="getLog"){
  $start = ($_POST['start'] == '')? 0: $_POST['start'];   // start record
  $limit = ($_POST['limit'] =='')? 10: $_POST['limit'];   // page limit
  $init = $_POST['init'];         // init log data

  // initialization log data to SESSION variable
  if($init == '1'){
    $logstore = array("totalCount"=>0, "logs"=>array());
    shell_exec("$modulepath/bin/elephantdrive.sh get_log");
    $fp = fopen($log_path, 'rb');
    while ( $cline = fgets($fp) ){
      $cline = trim($cline);
      list($datetime, $desc) = explode('|',$cline, 2);                   
      
      array_push($logstore['logs'], array('datetime'=>trim($datetime),
                                          'desc'=>trim($desc)));
      $logstore['totalCount']++;
    }
    fclose($fp);

    //sorting
    $logstore_sort = array('logs'=>array(), 'totalCount'=>$logstore['totalCount']);
    $total = count($logstore['logs'])-1;
    $k=0;
    for($i=$total ;$i>=0; $i--){
      $logstore_sort['logs'][$k] = $logstore['logs'][$i];
      $k++;
    }
    $_SESSION['log'] = $logstore_sort;
  }

  // general page
  $count = $_SESSION['log']['totalCount'];
  $log = array();

  if( ($limit + $start)  > $count){
    $current_count = $count;
  }else{
    $current_count = $limit + $start;
  }

  for($i = $start; $i < $current_count; $i++){
    $log[]= $_SESSION['log']['logs'][$i];
  }
  
  die(json_encode(
                  array('totalCount'=>$count,'logs'=>$log)
  ));
  exit;
}else if ($ac=="truncate"){
  $today=date("D M j G:i:s Y");
  shell_exec("echo \"". $today . "\" > ". $log_path);
  shell_exec("echo \"|INFO| ". $words['truncate_finish'] . "\" >> " .$log_path);
  exit;
}else if ($ac=="register"){
  if (($email=="") || ($password=="")){
    echo "{success:false, msg:'".$words["fail"]."'}";
    exit;
  }

  if ((strlen($password) < 6) || (strlen($password) > 12)){
    echo "{success:false, msg:'".$words["password_len_limit"]."'}";
    exit;
  }
	
  //check the email is registered?
  $ret=trim(shell_exec("$modulepath/bin/elephantdrive.sh check_email '". $email . "'"));
  if ($ret=="True"){
    echo "{success:true, msg:'".$words["email_fail"]."'}";
    exit;
  }
  
  $ret=trim(shell_exec("$modulepath/bin/elephantdrive.sh register '". $email . "' '" . getPasswordHash($password) . "'"));
  if ($ret=="True"){
    echo "{success:true, msg:'".$words["register_ok"]."'}";
  }else{
    echo "{success:true, msg:'".$ret."'}";
  }

  exit;
}

if (($enable==$o_enable) && ($email==$o_email) && ($password==$o_password)){
  echo "{success:true, msg:'".$words["setting_confirm"]."'}";
  exit;
}

if ($enable=="1"){
  if (($email=="") || ($password=="")){
    echo "{success:false, msg:'".$words["fail"]."'}";
    exit;
  }

  shell_exec("$sqlite $confdb \"update conf set v='$enable' where k='elephant_enable'\"");
  shell_exec("$sqlite $confdb \"update conf set v='$email' where k='email'\"");
  shell_exec("$sqlite $confdb \"update conf set v='$password' where k='password'\"");
  
  shell_exec("$modulepath/bin/elephantdrive.sh start > /dev/null 2>&1 &");
  echo "{success:true, msg:'".$words["enableservice"]."'}";
}else{
  shell_exec("$sqlite $confdb \"update conf set v='$enable' where k='elephant_enable'\"");
  shell_exec("$modulepath/bin/elephantdrive.sh stop");
  echo "{success:true, msg:'".$words["disableservice"]."'}";
}

?>
